osgFX::Effect Class Referenceabstract

`#include <Effect>`

Inheritance diagram for osgFX::Effect:

## Public Types

enum | TechniqueSelection { AUTO_DETECT = -1 }
Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| Effect ()
| Effect (const Effect &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual bool | isSameKindAs (const osg::Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual const char * | effectName () const =0
virtual const char * | effectDescription () const =0
virtual const char * | effectAuthor () const =0
bool | getEnabled () const
void | setEnabled (bool v)
virtual void | setUpDemo ()
int | getNumTechniques () const
Technique * | getTechnique (int i)
const Technique * | getTechnique (int i) const
int | getSelectedTechnique () const
void | selectTechnique (int i=AUTO_DETECT)
virtual void | traverse (osg::NodeVisitor &nv)
void | inherited_traverse (osg::NodeVisitor &nv)
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *state=0) const
Public Member Functions inherited from osg::Group
| Group ()
| Group (const Group &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Group)
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual bool | addChild (Node *child)
template<class T>
bool | addChild (const ref_ptr< T > &child)
virtual bool | insertChild (unsigned int index, Node *child)
template<class T>
bool | insertChild (unsigned int index, const ref_ptr< T > &child)
virtual bool | removeChild (Node *child)
template<class T>
bool | removeChild (const ref_ptr< T > &child)
bool | removeChild (unsigned int pos, unsigned int numChildrenToRemove=1)
virtual bool | removeChildren (unsigned int pos, unsigned int numChildrenToRemove)
virtual bool | replaceChild (Node *origChild, Node *newChild)
template<class T, class R>
bool | replaceChild (const ref_ptr< T > &origChild, const ref_ptr< R > &newChild)
virtual unsigned int | getNumChildren () const
virtual bool | setChild (unsigned int i, Node *node)
Node * | getChild (unsigned int i)
const Node * | getChild (unsigned int i) const
bool | containsNode (const Node *node) const
template<class T>
bool | containsNode (const ref_ptr< T > &node) const
unsigned int | getChildIndex (const Node *node) const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual BoundingSphere | computeBound () const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~Effect ()
Effect & | operator= (const Effect &)
void | dirtyTechniques ()
void | addTechnique (Technique *tech)
virtual bool | define_techniques ()=0
Protected Member Functions inherited from osg::Group
virtual | ~Group ()
virtual void | childRemoved (unsigned int, unsigned int)
virtual void | childInserted (unsigned int)
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Friends

class | Validator

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Attributes inherited from osg::Group
NodeList | _children
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Detailed Description

The base class for special effects. An effect is basically a collection of state attributes and an interface for configuring them in a predefined fashion. The Effect class does more however, as it handles multipass rendering transparently and it allows more than one "technique" to be defined. Each technique tries to implement the effect in a different way, often using different OpenGL extensions. The active technique can be selected either manually, with selectTechnique(), or automatically, in which case the first technique that is supported by all active rendering contexts is chosen. If you are an Effect user, then simply use it as a node group. Create an instance of your desired effect, add it to your scene graph and call its addChild() method to add a child node as you would do with a Group. If you are an Effect developer, you will have to implement the method define_techniques() to define the different techniques that can be used for obtaining the desired effect. In define_techniques() you will usually create one or more instances of custom classes derived from Technique and you will add them to the effect with addTechnique(). The order is important: techniques added first will have higher priority and will be used first as soon as all rendering contexts support it.

## Member Enumeration Documentation

## TechniqueSelection

enum osgFX::Effect::TechniqueSelection

Enumerator
AUTO_DETECT |

## Constructor & Destructor Documentation

## Effect() [1/2]

osgFX::Effect::Effect | ( |  | ) |

Referenced by Effect(), isSameKindAs(), operator=(), and osgFX::Outline::Outline().

## Effect() [2/2]

osgFX::Effect::Effect | ( | const Effect & | copy,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

References Effect(), and osg::CopyOp::SHALLOW_COPY.

## ~Effect()

virtual osgFX::Effect::~Effect | ( |  | ) |

protected virtual

## Member Function Documentation

## addTechnique()

void osgFX::Effect::addTechnique | ( | Technique * | tech | ) |

inline protected

add a technique to the Effect

## className()

virtual const char * osgFX::Effect::className | ( |  | ) | const

inline virtual

return the name of the node's class type.

Reimplemented from osg::Node.

## define_techniques()

virtual bool osgFX::Effect::define_techniques | ( |  | ) |

protected pure virtual

abstract method to be implemented in derived classes; its purpose if to create the techniques that can be used for obtaining the desired effect. You will usually call addTechnique() inside this method.

Implemented in osgFX::AnisotropicLighting, osgFX::BumpMapping, osgFX::Cartoon, osgFX::Outline, osgFX::Scribe, and osgFX::SpecularHighlights.

## dirtyTechniques()

void osgFX::Effect::dirtyTechniques | ( |  | ) |

inline protected

force rebuilding of techniques on next traversal

Referenced by osgFX::BumpMapping::setDiffuseTextureUnit(), osgFX::AnisotropicLighting::setLightNumber(), osgFX::BumpMapping::setLightNumber(), osgFX::Cartoon::setLightNumber(), osgFX::SpecularHighlights::setLightNumber(), osgFX::BumpMapping::setNormalMapTextureUnit(), osgFX::BumpMapping::setOverrideDiffuseTexture(), osgFX::BumpMapping::setOverrideNormalMapTexture(), osgFX::SpecularHighlights::setSpecularColor(), osgFX::SpecularHighlights::setSpecularExponent(), and osgFX::SpecularHighlights::setTextureUnit().

## effectAuthor()

virtual const char * osgFX::Effect::effectAuthor | ( |  | ) | const

pure virtual

get the effect author's name

References getEnabled(), and setEnabled().

## effectDescription()

virtual const char * osgFX::Effect::effectDescription | ( |  | ) | const

pure virtual

get a brief description of this Effect

## effectName()

virtual const char * osgFX::Effect::effectName | ( |  | ) | const

pure virtual

get the name of this Effect

Referenced by osgFX::Registry::registerEffect(), and osgFX::Registry::removeEffect().

## getEnabled()

bool osgFX::Effect::getEnabled | ( |  | ) | const

inline

get whether the effect is enabled or not

Referenced by effectAuthor().

## getNumTechniques()

int osgFX::Effect::getNumTechniques | ( |  | ) | const

inline

get the number of techniques defined for this Effect

## getSelectedTechnique()

int osgFX::Effect::getSelectedTechnique | ( |  | ) | const

inline

get the index of the currently selected Technique

## getTechnique() [1/2]

Technique * osgFX::Effect::getTechnique | ( | int | i | ) |

inline

get the i-th Technique

## getTechnique() [2/2]

const Technique * osgFX::Effect::getTechnique | ( | int | i | ) | const

inline

get the i-th const Technique

## inherited_traverse()

void osgFX::Effect::inherited_traverse | ( | osg::NodeVisitor & | nv | ) |

inline

default traversal

Referenced by traverse().

## isSameKindAs()

virtual bool osgFX::Effect::isSameKindAs | ( | const osg::Object * | obj | ) | const

inline virtual

return true if this and obj are of the same kind of object.

Reimplemented from osg::Node.

References Effect(), and NULL.

## libraryName()

virtual const char * osgFX::Effect::libraryName | ( |  | ) | const

inline virtual

return the name of the node's library.

Reimplemented from osg::Node.

## operator=()

Effect & osgFX::Effect::operator= | ( | const Effect & |  | ) |

inline protected

References Effect().

## releaseGLObjects()

virtual void osgFX::Effect::releaseGLObjects | ( | osg::State * | = 0 | ) | const

virtual

If State is non-zero, this function releases any associated OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objects for all graphics contexts.

Reimplemented from osg::Group.

## resizeGLObjectBuffers()

virtual void osgFX::Effect::resizeGLObjectBuffers | ( | unsigned int | maxSize | ) |

virtual

Resize any per context GLObject buffers to specified size.

Reimplemented from osg::Group.

## selectTechnique()

void osgFX::Effect::selectTechnique | ( | int | i = AUTO_DETECT | ) |

inline

select a technique or enable automatic detection

## setEnabled()

void osgFX::Effect::setEnabled | ( | bool | v | ) |

inline

set whether the effect is enabled or not

Referenced by effectAuthor().

## setUpDemo()

virtual void osgFX::Effect::setUpDemo | ( |  | ) |

inline virtual

optional: set effect parameters to produce a visually significant result to be used in demo applications like osgfxbrowser. Default is to do nothing.

Reimplemented in osgFX::BumpMapping.

## traverse()

virtual void osgFX::Effect::traverse | ( | osg::NodeVisitor & | nv | ) |

virtual

custom traversal

Reimplemented from osg::Group.

References inherited_traverse().

## Friends And Related Symbol Documentation

## Validator

friend class Validator

friend

References Validator.

Referenced by Validator.

The documentation for this class was generated from the following file:

- Effect